<template>
	<f7-page name="marketplacedetail" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false">
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="product != null && product.category" class="show-small-title">{{ product.category.name }}</f7-nav-title>
            <f7-nav-right v-if="product != null">
                <f7-link :href="`/marketplace/product/${product.id}/comments/`">
                    <f7-icon ios="f7:chat" aurora="f7:chat" md="f7:chat" class="icon f7-icons">
					    <f7-badge color="red">{{ product.total_comment.kformat() }}</f7-badge>					
				    </f7-icon>
                </f7-link>
            </f7-nav-right>
		</f7-navbar>
        <f7-block v-if="product != null">
            <f7-swiper v-if="product.medias.length > 0" pagination :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
                <f7-swiper-slide class="marketplace-has-browser" v-for="item in product.medias" v-bind:key="item.id">
                    <span class="image-thumb" :style="`background-image: url(${item.url.medium});`"></span>
                </f7-swiper-slide>
            </f7-swiper>
            <f7-swiper v-else :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
                <f7-swiper-slide>
                    <span class="image-thumb" :style="`background-image:url(${require('../assets/no-photo.jpg')})`"></span>
                </f7-swiper-slide>
            </f7-swiper>            
        </f7-block>   
        <f7-block v-if="product != null" class="product-detail">
            <h3 class="no-margin-bottom">{{ product.title }}</h3>
            <small class="display-block margin-small-bottom">Terakhir Diperbaharui: {{ dateFormat(product.updated, 'DD MMMM YYYY') }}</small>
            <div class="display-block" style="margin:20px 0;">
                <div v-if="product.discount > 0">
                    <small class="display-block color-red"><s style="font-size:24px;">Rp {{ product.price.format(0,0,'.',',') }}</s></small>
                    <span style="font-size:24px;" class="display-block color-green">Rp {{ calculateDiscount(product.price, product.discount).format(0,0,'.',',') }} / {{ product.unit.name }}</span>
                </div>
                <div v-else>
                    <span style="font-size:24px;" class="display-block color-green">Rp {{ product.price.format(0,0,'.',',') }} / {{ product.unit.name }}</span>
                </div>
            </div>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;">{{ product.description }}</span>
            <span v-if="product.author.profile.store_open != null && product.author.profile.store_close != null" class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;"><f7-icon f7="time" size="18px" color="green"></f7-icon> <strong>Buka</strong> dari <strong>{{ product.author.profile.store_open }}</strong> - <strong>{{ product.author.profile.store_close }}</strong></span>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;"><f7-icon f7="barcode" size="18px" color="lightyellow"></f7-icon> {{ product.conditions == 'new' ? 'Baru' : 'Bekas' }}</span>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;"><f7-icon f7="bag" size="18px" color="lightblue"></f7-icon> Pesanan minimum {{ product.minorder }} {{ product.unit.name }}</span>
            <span v-if="product.isdeliverable" class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;"><f7-icon f7="navigation" size="18px" color="lightpurple"></f7-icon> <span v-if="product.delivery_cost > 0">Pesan Antar dikenakan biaya <strong>{{ ' Rp ' + product.delivery_cost.format(0,0,'.',',')}}</strong></span>
            <span v-else>Pesan Antar <strong>GRATIS</strong></span>
            </span>
            <span v-if="product.isnegotiable" class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;"><f7-icon f7="tag" size="18px" color="orange"></f7-icon> Harga bisa dinegosiasikan</span>
            <f7-link :href="`/marketplace/store/${product.author.id}/`" class="display-block">
                <f7-icon f7="placemark" size="18px" color="pink"></f7-icon> {{ product.author.profile.store_name != null ? product.author.profile.store_name : product.author.profile.fullname }}, <span v-if="product.author.profile.latitude != null && product.author.profile.longitude != null"> {{ distance(currentLocation.latitude, currentLocation.longitude, product.author.profile.latitude, product.author.profile.longitude) }}</span>
                <span v-else>{{ distance(currentLocation.latitude, currentLocation.longitude, product.latitude, product.longitude) }}</span>
            </f7-link>
            <br>
            <f7-button v-if="product.author.id != user.id" @click="showActionSheet" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>Hubungi Penjual</f7-button>
            </f7-block>             
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, distance } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'MarketplaceDetail',
    data(){
        return {
            photoBrowser: null
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('chat', ['chat']),
		...mapGetters('product', [
			'product'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    methods: {
        dateFormat,
        distance,
        calculateDiscount(price, discount){
            return price - (price * discount) / 100;
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

            self.$store.dispatch('product/viewProduct', {
                id: self.$f7route.params.id,
                only: 'id,conditions,title,slug,description,minorder,price,delivery_cost,discount,isdeliverable,isnegotiable,latitude,longitude,category.id,category.name,category.slug,created,updated,unit.id,unit.name,unit.symbol,author.id,author.profile.fullname,author.profile.phone,author.profile.store_name,author.profile.store_about,author.profile.store_open,author.profile.store_close,author.profile.latitude,author.profile.longitude,medias,total_comment'
            }).then(() => {
                app.preloader.hide();
                self.photoBrowserInit();
            });
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;

            self.photoBrowser.destroy();
        },
        photoBrowserInit(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            if(self.product.medias != null){
                let medias = self.product.medias.map((x) => x.url.original);
                self.photoBrowser = app.photoBrowser.create({
                    photos: medias,
                    type: 'popup'
                });

                $$(document).on('click', '.marketplace-has-browser', function(){
                    self.photoBrowser.open();
                });
            }
        },
        showActionSheet(){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: self.product.author.profile.store_name != null ? self.product.author.profile.store_name : self.product.author.profile.fullname,
                label: true
            }, {
                text: 'Panggilan Telp',
                close: true,
                onClick: function(actions, e){
                    location.href = "tel:"+self.product.author.profile.phone.replace('0','+62');
                }
            }, {
                text: 'Chat',
                close: true,
                onClick: function(actions, e){
                    app.preloader.show('green');
                    self.$store.dispatch('chat/createChat', {
                        recipient_id: self.product.author.id
                    }).then((response)=>{
                        app.preloader.hide();
                        setTimeout(()=>{
                            self.$f7router.navigate('/chat/'+self.chat.id+'/messages/', {
                                ignoreCache: true
                            });
                        }, 100);
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
        }
    }
}
</script>
